#serial 3

# WIS_CHECK_SIZEOF
# ----------------
# $1 is the type
AC_DEFUN([WIS_CHECK_SIZEOF], [
  if test $# -eq 1; then 
    AC_MSG_CHECKING(sizeof $1)
  fi
  arg1=`echo $1 | sed 's/ /_/g'`
  AC_TRY_RUN([
#include <stdio.h>
#include <sys/types.h>
int main()
{
  FILE *f=fopen("conftestval", "w");
  if (!f) exit(1);
  fprintf(f, "%d\n", sizeof($1));
  exit(0);
}],[read sz <./conftestval],[sz=0],[sz=0])
  eval "ac_cv_sizeof_$arg1=$sz"
  if test $# -eq 1; then
    AC_MSG_RESULT($sz)
  fi
])

# CCIN2P3_CHECK_RFIO
# ------------------
# $1 is action if found
# $2 is action if not found
# $3 is rfio root dir
AC_DEFUN([CCIN2P3_CHECK_RFIO],[
OLDLDFLAGS="$LDFLAGS"
OLDCPPFLAGS="$CPPFLAGS"
OLDLIBS=$LIBS

rfio_root_dir=$3

# LDFLAGS="$LDFLAGS -L$rfio_root_dir/lib"
LIBS="$LIBS $rfio_root_dir/lib/libshift.a"
CPPFLAGS="$CPPFLAGS -I$rfio_root_dir/include -I$rfio_root_dir/include/shift"
AC_SEARCH_LIBS([getservbyname_r],[socket xnet])
AC_SEARCH_LIBS([sched_get_priority_max],[rt posix4])
AC_CHECK_FILE([$rfio_root_dir/include/shift/rfio_api.h],[result=yes],[result=no])
if test $result = yes ; then
    AC_SEARCH_LIBS([pthread_create],[pthread pthreads dce])
    AC_SEARCH_LIBS([pthread_kill],[pthread pthreads])
    AC_CHECK_FUNC([rfio_open64],[AC_DEFINE(WITH_RFIO64, [], [Defined if RFIO has been included and defines which version])])
else
    AC_CHECK_FUNC([rfio_open],[AC_DEFINE(WITH_RFIO, [], [Defined if RFIO has been included and defines which version])])
fi
if test "$ac_cv_func_rfio_open64" = "no" || test "$ac_cv_func_rfio_open" = "no" ; then
    LDFLAGS="$OLDLDFLAGS"
    CPPFLAGS="$OLDCPPFLAGS"
    LIBS="$OLDLIBS"
    ccin2p3_cv_rfio=no
else
    AC_CHECK_HEADERS([shift.h],,[ AC_MSG_ERROR(shift.h not found in $CPPFLAGS)])
#    LIBS="$LIBS $rfio_root_dir/lib/libshift.a"
    LDFLAGS="$OLDLDFLAGS"
    dnl in RFIO 32 bits, rfio_HsmIf_FindPhysicalPath means CASTOR is supported
    if test "$ac_cv_func_rfio_open" = "yes" ; then
        AC_CHECK_FUNC([rfio_HsmIf_FindPhysicalPath],[result=yes],[result=no])
        if test $result = yes ; then
            dnl add xxx/shift include dir for stage_api.h
            dnl CPPFLAGS="$CPPFLAGS -I$rfio_root_dir/include/shift"
            AC_CHECK_HEADER([stage_api.h],[result=yes],[AC_MSG_ERROR(shift/stage_api.h not found in $CPPFLAGS)])
            AC_DEFINE(CASTOR, [], [Defined if RFIO castor library is present])
        fi
    else
        dnl in RFIO 64 bits, rfio_setcos means CASTOR is not supported
        AC_CHECK_FUNC([rfio_setcos],[result=yes],[result=no])
        if test $result = no ; then
            dnl add xxx/shift include dir for stage_api.h
            dnl CPPFLAGS="$CPPFLAGS -I$rfio_root_dir/include/shift"
            AC_CHECK_HEADER([stage_api.h],[result=yes],[AC_MSG_ERROR(shift/stage_api.h not found in $CPPFLAGS)])
            AC_CHECK_FUNCS([stageclr_Path])
            AC_DEFINE(CASTOR, [], [Defined if RFIO castor library is present])
        fi
    fi
    ccin2p3_cv_rfio=yes
fi
if test $ccin2p3_cv_rfio = yes; then
    $1
else
    $2
fi
])
